/***************************************************************************
 *   Copyright (C) 2005 by Paul Lutus   *
 *   lutusp@pl-alpha   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONTROLPANELMANAGER_H
#define CONTROLPANELMANAGER_H

#include <qtabwidget.h>
#include <qlineedit.h>
#include <qpixmap.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qevent.h>

#include <lens.h>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <raytracerwidgetcode.h>
#include <traceanddraw.h>

typedef vector<Lens*> VL;
typedef VL::iterator VLI;

/**
@author Paul Lutus
*/
class ControlPanelManager{
public:
    ControlPanelManager(RayTracerWidgetCode *p);

    ~ControlPanelManager();

Lens *currentLens;

bool inhibit;

void updateLensDisplay(Lens *lens);
void changeLens();
template <class A> string formattedNumber(A v);
template <class A> void loadLineEdit(QLineEdit *le, A v);
void retrieveLineEdit(QLineEdit *p,double &v);
void loadCheckBox(QCheckBox *cb,bool state);
void retrieveCheckBox(QCheckBox *cb,bool &state);
void enableControlPanel(bool state);
template <class A, class B>
void convertValue(A s,B &v);
void newLens();
void cloneLens();
void deleteLens();
void writeGlobalDisplay();
void readGlobalDisplay();

RayTracerWidgetCode *parent;
};

#endif
