/***************************************************************************
 *   Copyright (C) 2004 by Paul Lutus                                      *
 *   lutusp@arachnoid.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "helpwidget.h"
#include "HelpText.h"
#include "raytracerwidgetcode.h"

HelpWidget::HelpWidget(QWidget *par,RayTracerWidgetCode* p, const char* name, WFlags fl)
        : HelpForm(par,name,fl) {
    parent = p;
    loadFile();
}

HelpWidget::~HelpWidget() {}

/*$SPECIALIZATION$*/

void HelpWidget::loadFile() {
    string help = HelpText;
    help = searchReplace(help,"[PROGDIR]",parent->progPath,true);
    helpBrowser->setText(help);
}

void HelpWidget::helpSearchString() {
    searchString->setBackgroundColor(QColor(255,255,255));
    string s = searchString->text();
    if(oldSearch != s) {
        helpBrowser->setSelection(0,0,0,0);
    }
    if(!helpBrowser->find(s,false,false)) {
        QApplication::beep();
        helpBrowser->setSelection(0,0,0,0);
        //printf("not found.\n");
        //fflush(stdout);
        searchString->setBackgroundColor(QColor(255,240,240));
    }
    oldSearch = s;
}

string HelpWidget::searchReplace(string& data, string find, string replace, bool global) {
    string r;
    size_t a = 0,b;
    size_t len = find.length();
    while((b = data.find(find,a)) != string::npos) {
        r += data.substr(a,b-a) + replace;
        a = b + len;
	if(!global) break;
    }
    r += data.substr(a);
    return r;
}

#include "helpwidget.moc"

