/***************************************************************************
 *   Copyright (C) 2005 by Paul Lutus   *
 *   lutusp@pl-alpha   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TRACEANDDRAW_H
#define TRACEANDDRAW_H

#include <cmath>
#include <qpainter.h>
#include <raytracecomputer.h>
#include <raytracerwidgetcode.h>
#include <box.h>
#include <iostream>
#include <sstream>
#include <string>
#include <lens.h>

typedef vector<Lens*> VL;
typedef VL::iterator VLI;

typedef vector<RayLensIntersection> VC;
typedef VC::iterator VCI;

/**
@author Paul Lutus
*/
class TraceAndDraw {
public:
    TraceAndDraw(RayTracerWidgetCode *p);

    ~TraceAndDraw();

    VL lensVec;

    QPixmap *qpm;

    RayTracerWidgetCode *parent;

    void drawBaseline(QPainter &pixpainter);
    void rayTraceProcess(bool paint = true);
    void drawGrid(QPainter &pixpainter);
double gridRound(double v,double modulus,bool roundUp = false);
    void updateStatusLabel(int mx, int my,bool inWindow);
string dispRoundNum(double v);
    void updateBuffer(bool raytrace = false);
    void makeDefaultLenses();
void drawBoxes(QPainter &pixpainter);
    void drawLenses(QPainter &pixpainter);
    void traceRays(QPainter &pixpainter);
    void traceOneRay(double x1, double y1, double x2, double y2,QPainter &pixpainter,VL lensVec,QColor &beamColor,double wavelength);

};

#endif
